(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("vis-requestor", [], factory);
	else if(typeof exports === 'object')
		exports["vis-requestor"] = factory();
	else
		root["vis-requestor"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _util = __webpack_require__(1);
	
	var _util2 = _interopRequireDefault(_util);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var defaultOpt = {
	  onSessionExpired: function onSessionExpired() {},
	
	  ajaxOption: {
	    method: 'POST'
	  },
	
	  token: {
	    checkBeforeSend: true,
	    addToHeader: false,
	    cookieName: 'token',
	    headerName: 'X-Token'
	  },
	
	  resultCode: {
	    SESSION_EXPIRED: Symbol(),
	    SUCCEED: Symbol()
	  },
	
	  urlOption: {
	    host: '',
	    port: '',
	    base: ''
	  },
	
	  alert: function alert(msg) {
	    window.alert(msg);
	  },
	
	  failedMsg: ''
	};
	
	function requestor(jquery, globalOpt) {
	  var objOptions = ['ajaxOption', 'token', 'resultCode', 'urlOption'];
	  objOptions.forEach(function (option) {
	    globalOpt[option] = Object.assign({}, defaultOpt[option], globalOpt[option]);
	  });
	
	  globalOpt = Object.assign({}, defaultOpt, globalOpt);
	
	  globalOpt.ajaxOption.dataType = 'json';
	
	  var asyncAlert = function asyncAlert(msg) {
	    if (!msg) return;
	    setTimeout(function () {
	      globalOpt.alert(msg);
	    }, 0);
	  };
	
	  function getTokenFromCookie(tokenName) {
	    var tokenRE = new RegExp('(?:; )?' + tokenName + '=([^;]*);?');
	    return tokenRE.test(document.cookie) ? decodeURIComponent(RegExp.$1) : '';
	  }
	
	  function request(option) {
	    var tokenOption = globalOpt.token;
	    var token = getTokenFromCookie(tokenOption.cookieName);
	
	    if (tokenOption && tokenOption.addToHeader && token) {
	      if (!option.headers) option.headers = {};
	      option.headers[tokenOption.headerName] = token;
	    }
	
	    var sessionExpiredResult = {
	      code: globalOpt.resultCode.SESSION_EXPIRED,
	      msg: 'Session expired!',
	      result: {}
	    };
	
	    if (tokenOption.checkBeforeSend && !token) {
	      globalOpt.onSessionExpired();
	      return new Promise(function (resolve, reject) {
	        reject(sessionExpiredResult);
	      });
	    }
	
	    if (option.data instanceof FormData) {
	      option.processData = false;
	      option.contentType = false;
	    }
	
	    return new Promise(function (resolve, reject) {
	      jquery.ajax(option).then(function (res, status, xhr) {
	        var code = res.code;
	
	        if (code === globalOpt.resultCode.SUCCEED) {
	          resolve(res);
	        } else {
	          // failed
	          if (code === globalOpt.resultCode.SESSION_EXPIRED) {
	            globalOpt.onSessionExpired();
	            reject(sessionExpiredResult);
	          } else {
	            reject(res);
	            asyncAlert(res.msg);
	          }
	        }
	      }, function (xhr) {
	        reject(xhr);
	        asyncAlert(globalOpt.failedMsg);
	      });
	    });
	  }
	
	  function requestJSON(apiOption, data) {
	    var currOption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	
	    var option = _util2.default.mergeAjaxOption(globalOpt.ajaxOption, apiOption, currOption, {
	      data: data
	    });
	
	    option.url = _util2.default.normalizeUrl(jquery, option.url, option.query, globalOpt.urlOption);
	    delete option.query;
	
	    var contentType = option.contentType;
	    var contentTypeIsJson = contentType && contentType.includes('application/json');
	    var processData = !contentTypeIsJson && !(option.processData === false);
	    if (processData && jquery.isPlainObject(option.data)) {
	      _util2.default.stringifyData(option.data);
	    }
	
	    if (contentTypeIsJson && typeof option.data !== 'string' && !(option.data instanceof FormData)) {
	      option.data = JSON.stringify(option.data);
	    }
	
	    return request(option);
	  }
	
	  function requestAPI() {
	    return requestJSON.apply(undefined, arguments).then(function (res) {
	      return res.result;
	    });
	  }
	
	  return {
	    request: request,
	    requestAPI: requestAPI,
	    requestJSON: requestJSON };
	}
	
	exports.default = requestor;

/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	var HTTP_PROTOCOL = /^http[s]?:\/\//;
	
	function normalizeUrl(jquery, url, query, option) {
	  var fullUrl = url;
	  if (!HTTP_PROTOCOL.test(url)) {
	    fullUrl = option.host || '';
	
	    if (option.port) {
	      fullUrl += option.port ? ':' + option.port : '';
	    }
	
	    if (option.base) {
	      fullUrl += option.base;
	    }
	
	    if (url) fullUrl += url;
	  }
	
	  if (query && Object.keys(query).length) {
	    var connChar = fullUrl.includes('?') ? '&' : '?';
	    fullUrl += connChar + jquery.param(query);
	  }
	
	  return fullUrl;
	}
	
	function mergeAjaxOption() {
	  for (var _len = arguments.length, options = Array(_len), _key = 0; _key < _len; _key++) {
	    options[_key] = arguments[_key];
	  }
	
	  var option1 = options.shift() || {};
	  var option2 = options.shift() || {};
	
	  var query = _extends({}, option1.query, option2.query);
	
	  var data = option2.data || option1.data;
	  var data1IsObj = option1.data && _typeof(option1.data) === 'object';
	  var data2IsObj = option2.data && _typeof(option2.data) === 'object';
	  var data1IsFormData = option1.data instanceof FormData;
	  var data2IsFormData = option2.data instanceof FormData;
	  if (!data1IsFormData && !data2IsFormData && data1IsObj && data2IsObj) {
	    data = _extends({}, option1.data, option2.data);
	  }
	
	  var headers = _extends({}, option1.headers, option2.headers);
	
	  var mergedResult = _extends({}, option1, option2, {
	    query: query,
	    data: data,
	    headers: headers
	  });
	
	  if (options.length) {
	    options.unshift(mergedResult);
	    return mergeAjaxOption.apply(undefined, options);
	  } else {
	    return mergedResult;
	  }
	}
	
	function stringifyData(data) {
	  for (var p in data) {
	    var dp = data[p];
	    if ((typeof dp === 'undefined' ? 'undefined' : _typeof(dp)) === 'object' && dp !== null) {
	      data[p] = JSON.stringify(dp);
	    }
	  }
	}
	
	exports.default = {
	  normalizeUrl: normalizeUrl,
	  mergeAjaxOption: mergeAjaxOption,
	  stringifyData: stringifyData
	};

/***/ }
/******/ ])
});
;
//# sourceMappingURL=vis-requestor.js.map